package utilities.shutdownHook;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class ShutdownHook extends Thread
{
	protected static transient final Log logger = LogFactory.getLog(ShutdownHook.class);

	private ShutdownHookClass tc;
	
	private boolean isActivated = false;		//true if shutdownhook activated


	public ShutdownHook(ShutdownHookClass tc)
	{
		this.tc = tc;
		logger.debug("ShutdownHook registered for " + tc.getClass().getName());
		Runtime.getRuntime().addShutdownHook(this);
	}

	public void remove()
	{
		Runtime.getRuntime().removeShutdownHook(this);
	}

	public void run()
	{
		if(tc != null)
		{
			logger.debug("ShutdownHook activated for " + this.getClass().getName() + ". Thread: " + Thread.currentThread().getName());
			isActivated = true;	//shutdown
			tc.shutdownHookCallback();
		}
		else
		{
			logger.debug("ShutdownHook safely release for " + this.getClass().getName() + ". Thread: " + Thread.currentThread().getName());
		}
	}
	
	public boolean isActivated()
	{
		return(isActivated);
	}
}